﻿// Goldie: GOLD Engine for D
// Written in the D programming language.

/++
$(WEB http://www.semitwist.com/goldie/, Goldie Homepage)

Goldie is licensed under The zlib/libpng License. See LICENSE.txt for details.

Author:
$(WEB www.semitwist.com, Nick Sabalausky)

This has been tested to work with DMD 2.052

In SVN comments:
(B): Includes breaking changes
(NB): No Breaking changes
However, even a (NB) revision might still require
static languages to be re-generated.
+/

//TODO: Encapsulate file(line:col) string generation
//TODO: Fix: error reporting for col of root token is wrong (-1 converted to unsigned?)

module /+S:PACKAGE+/goldie/+E:PACKAGE+/.all;

/// Note: goldie.file, goldie.grmc.* and goldie.langs.* are not imported here
/// because the vast majority of apps will not need to use them directly.

/+P:SET_VERSION+/

/+S:REM+/
public import goldie.base;
public import goldie.exception;
public import goldie.lang;
public import goldie.lexer;
public import goldie.parser;
public import goldie.token;
public import goldie.ver;
/+E:REM+/

version(GoldieStaticLang)
{
	public import /+P:PACKAGE+/DUMMY.lang;
	public import /+P:PACKAGE+/DUMMY.lexer;
	public import /+P:PACKAGE+/DUMMY.parser;
	public import /+P:PACKAGE+/DUMMY.token;
}

//TODO? Make sanity checks execute in debug-mode only
//TODO? Sanitize usages of terminology like "symbol", "token name" etc. in class Token
//TODO: Make modification of calculator* that builds an AST and saves as XML instead of calculating.
//TODO: Add StringOf to Token_{languageName}!() and Token
//TODO: Fix: Lexer_{languageName}.process() takes a Language as a parameter (Also 'Parser_').
//TODO: Check on incorrect line/col reported upon lexer error that spans
//      multiple lines and ends with EOL.
//TODO? Add skeleton "process" func in generated static-style.
